/*
Copyright Renaud GICQUEL 2005-2006  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.util.*;
import rg.thopt.*;
import java.io.*;

/**
 * Classe pour calculer la pousse spcifique et la consommation spcifique d'un turboracteur
 * 
 * Elle fait appel aux classes Diffuser et Nozzle ainsi qu' la structure d'un turboracteur
 * telle que schmatise dans l'exemple simpleFlux_Ss_post.dia
 *
 * On entre  l'cran le nombre de Mach de l'avion et la pression et la temprature extrieure
 *
 * Le taux de compression est donn en paramtre
 *
 * Thrust met  jour les crans de Thermoptim et effectue quelques recalculs avant d'afficher les rsultats
 *
 * Cette classe illustre la manire dont une classe externe peut piloter des reparamtrages 
 * varis d'un projet de structure donne
 *
 * @author Renaud GICQUEL
 */
public class Thrust extends ExtPilot
{
	boolean isInitialized=false;
	Diffuser diff;
	Nozzle[] nozzle;//tableau, pour le cas o on voudrait traiter des double flux (non implment)
	boolean isBuilt=false;
	String[]composant,nomComposant,nomNozz;
    String combustionChamberName="",compressorName="",nomDiff="";

    double Ma,Pext,Text;
    double[]taux,thrust,conso;
	String tab=new String("\t");
	String ligne=new String("\n");
    

	public Thrust()
	{
		//{{INIT_CONTROLS
		setTitle("airplane thrust");
		getContentPane().setLayout(null);
		setSize(642,540);
		setVisible(false);
		bSimulate.setText("Simulate");
		bSimulate.setActionCommand("load");
		getContentPane().add(bSimulate);
		bSimulate.setBounds(408,372,156,48);
		JLabel1.setText("plane mach number");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(12,32,156,24);
		getContentPane().add(planeMach_value);
		planeMach_value.setBounds(180,32,96,24);
		planeMach_value.setText("1.5");
		planeMach_value.setSelectionColor(new java.awt.Color(204,204,255));
		planeMach_value.setSelectedTextColor(java.awt.Color.black);
		planeMach_value.setCaretColor(java.awt.Color.black);
		planeMach_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel2.setText("ambient pressure (bar)");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(12,68,156,24);
		getContentPane().add(ambiantP_value);
		ambiantP_value.setBounds(180,68,96,24);
		ambiantP_value.setText("0.265");
		ambiantP_value.setSelectionColor(new java.awt.Color(204,204,255));
		ambiantP_value.setSelectedTextColor(java.awt.Color.black);
		ambiantP_value.setCaretColor(java.awt.Color.black);
		ambiantP_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel3.setText("ambient temperature (K)");
		getContentPane().add(JLabel3);
		JLabel3.setBounds(12,104,156,24);
		getContentPane().add(ambientT_value);
		ambientT_value.setBounds(180,104,96,24);
		ambientT_value.setText("222.15");
		ambientT_value.setSelectionColor(new java.awt.Color(204,204,255));
		ambientT_value.setSelectedTextColor(java.awt.Color.black);
		ambientT_value.setCaretColor(java.awt.Color.black);
		ambientT_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel6.setText("compression ratio");
		getContentPane().add(JLabel6);
		JLabel6.setBounds(12,192,156,24);
		getContentPane().add(comprRatio_value);
		comprRatio_value.setBounds(180,192,96,24);
		comprRatio_value.setText("10");
		comprRatio_value.setSelectionColor(new java.awt.Color(204,204,255));
		comprRatio_value.setSelectedTextColor(java.awt.Color.black);
		comprRatio_value.setCaretColor(java.awt.Color.black);
		comprRatio_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel4.setText("specific thrust");
		getContentPane().add(JLabel4);
		JLabel4.setForeground(java.awt.Color.red);
		JLabel4.setBounds(12,228,156,24);
		thrust_value.setSelectionColor(new java.awt.Color(204,204,255));
		thrust_value.setSelectedTextColor(java.awt.Color.black);
		thrust_value.setCaretColor(java.awt.Color.black);
		thrust_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(thrust_value);
		thrust_value.setBounds(180,228,96,24);
		fuel_value.setSelectionColor(new java.awt.Color(204,204,255));
		fuel_value.setSelectedTextColor(java.awt.Color.black);
		fuel_value.setCaretColor(java.awt.Color.black);
		fuel_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(fuel_value);
		fuel_value.setBounds(180,264,96,24);
		JLabel5.setText("specific fuel consumption");
		getContentPane().add(JLabel5);
		JLabel5.setForeground(java.awt.Color.red);
		JLabel5.setBounds(12,264,156,24);
		bCalculate.setText("Calculate ");
		bCalculate.setActionCommand("Calculate ");
		getContentPane().add(bCalculate);
		bCalculate.setBounds(408,204,156,60);
		JLabel8.setText("initial compression ratio");
		getContentPane().add(JLabel8);
		JLabel8.setBounds(12,360,156,24);
		initComprRatio_value.setText("10");
		initComprRatio_value.setSelectionColor(new java.awt.Color(204,204,255));
		initComprRatio_value.setSelectedTextColor(java.awt.Color.black);
		initComprRatio_value.setCaretColor(java.awt.Color.black);
		initComprRatio_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(initComprRatio_value);
		initComprRatio_value.setBounds(180,360,96,24);
		JLabel9.setText("final compression ratio");
		getContentPane().add(JLabel9);
		JLabel9.setBounds(12,408,156,24);
		finalComprRatio_value.setText("100");
		finalComprRatio_value.setSelectionColor(new java.awt.Color(204,204,255));
		finalComprRatio_value.setSelectedTextColor(java.awt.Color.black);
		finalComprRatio_value.setCaretColor(java.awt.Color.black);
		finalComprRatio_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(finalComprRatio_value);
		finalComprRatio_value.setBounds(180,408,96,24);
		JLabel7.setText("Single compression ratio calculation");
		getContentPane().add(JLabel7);
		JLabel7.setForeground(java.awt.Color.blue);
		JLabel7.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel7.setBounds(24,156,553,25);
		JLabel10.setText("Exterior conditions");
		getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel10.setBounds(24,0,553,25);
		JLabel11.setText("Various compression ratios simulation");
		getContentPane().add(JLabel11);
		JLabel11.setForeground(java.awt.Color.blue);
		JLabel11.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel11.setBounds(24,324,553,25);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bSimulate.addActionListener(lSymAction);
		bCalculate.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		type="thrust";
	}

    /**
    * returns the component type 
    **/
    public String getCompType(){
        return type;
    }
    
	public String getClassDescription(){
	    return "driver for a simple flow turbojet project\n\nRequires external classes Nozzle and Diffuser\n\nauthor : R. Gicquel april 2006";
	}
    

	public void init(){
		isInitialized=true;
		proj=getProjet();
		setupProject();
		//On rcupre la liste et le type des composants prsents dans l'diteur de schmas
		//Gets the list and type of components in the diagram editor
		String[]listComp=proj.getEditorComponentList();
		composant=new String[listComp.length];
		nomComposant=new String[listComp.length];
		
		//on en extrait les noms des transfos du noyau dont on a besoin
		// savoir le compresseur et la chambre de combustion
		//we get the names of processes needed (i.e. the compressor and the combustion chamber
        for(int i=0;i<listComp.length;i++){
		    composant[i]=Util.extr_value(listComp[i], "type");
		    nomComposant[i]=Util.extr_value(listComp[i], "name");
		    if(composant[i].equals("Combustion"))combustionChamberName=nomComposant[i];
		    if(composant[i].equals("Compression"))compressorName=nomComposant[i];
        }
        
        //test de cohrence (des messages d'erreur plus prcis seraient souhaitables)
        //consistency tests (more specific error messages would be desirable)
        if((!combustionChamberName.equals(""))&&(!compressorName.equals(""))&& isBuilt)isBuilt=true;
		if(isBuilt)setVisible(true);//on n'ouvre le pilote que si sa structure est correcte
		//the driver is opened only if the structure is appropriate
        //initialisations pour la simulation (calculs pour 10 rapports de compression)
        //initializations for simulation (calculation forr 10 compression ratios)
        thrust=new double[10];
        conso=new double[10];
        taux=new double[10];
	}
	
    
    void setupProject(){
        //on rcupre ici les instances des transfos externes dont on a besoin
        //afin d'accder  leurs diffrents paramtres pour les calculs ultrieurs
    	//we get the instances of external processes needed in order to
    	//access their settings for subsequent calculations
        nozzle=new Nozzle[2];
        nomNozz=new String[2];
        nomNozz[0]="";
        nomNozz[1]="";
        Vector vExt=proj.getExternalClassInstances();//Vector contenant les classes externes
        											//Vector containing external classes
        int k=0,j=0;
        for(int i=0;i<vExt.size();i++){
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        ExtProcess ep=(ExtProcess)obj[1];
	        if(ep instanceof Diffuser){
	            diff=(Diffuser)ep;
	            nomDiff=diff.getName();
	            j++;
	        }
	        if(ep instanceof Nozzle){
	            nozzle[k]=(Nozzle)ep;
	            nomNozz[k]=nozzle[k].getName();
	            k++;
	        }
        }
        if(j*k==1)isBuilt=true;//test de cohrence du pilote par rapport au modle
        						//driver consistency test 
  }
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == Thrust.this)
			Thrust_WindowClosing(event);
		}
	}

	void Thrust_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JButton bSimulate = new javax.swing.JButton();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField planeMach_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField ambiantP_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField ambientT_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField comprRatio_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField thrust_value = new javax.swing.JTextField();
	javax.swing.JTextField fuel_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JButton bCalculate = new javax.swing.JButton();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JTextField initComprRatio_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JTextField finalComprRatio_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bSimulate)
				bSimulate_actionPerformed(event);
			else if (object == bCalculate)
				bCalculate_actionPerformed(event);
		}
	}

	void bSimulate_actionPerformed(java.awt.event.ActionEvent event)
	{
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	    
        Pext=Util.lit_d(ambiantP_value.getText());
        Text=Util.lit_d(ambientT_value.getText());
        diff.setAmbientConditions(Text, Pext);//mise  jour du point amont du diffuseur
	    nozzle[0].setExternalPressure(Pext);//mise  jour de la pression en aval de la tuyre
	    
        Ma=Util.lit_d(planeMach_value.getText());
	    double C=diff.getSpeed(Ma, Text, Pext);//mise  jour de la vitesse en amont du diffuseur
	    diff.setInletVelocity(C);	    
        
        taux[0]=Util.lit_d(initComprRatio_value.getText());
        taux[9]=Util.lit_d(finalComprRatio_value.getText());
        double ratio=Math.pow(taux[9]/taux[0],1./9.);
		for(int i=1 ;i<taux.length;i++){
			taux[i]=taux[i-1]*ratio;
		}
    	    
		for(int k=0 ;k<taux.length;k++){
	        double comprRatio=taux[k];
    	    
	        for(int i=0;i<3;i++){//on effectue 3 recalculs pour assurer la convergence
	            if(!compressorName.equals("")){//mise  jour du compresseur
                    String[] args=new String[2];
                    args[0]="process";
                    args[1]=compressorName;
                    Vector vProp=proj.getProperties(args);
                    String amont=(String)vProp.elementAt(1);
                    String aval=(String)vProp.elementAt(2);
                    args[0]="point";
                    args[1]=amont;
                    vProp=proj.getProperties(args);
                    Double f=(Double)vProp.elementAt(3);
                    double Pamont=f.doubleValue();
                    
                    //mise  jour du point aval du compresseur
                    double Paval=Pamont*comprRatio;
                    Vector vPoint=new Vector();
                    vPoint.addElement(aval);
                    vPoint.addElement("false");//update temperature
                    vPoint.addElement("0");
                    vPoint.addElement("true");//update pressure
                    vPoint.addElement(Util.aff_d(Paval));
                    vPoint.addElement("false");
                    vPoint.addElement("1");
                    proj.updatePoint(vPoint);
	            }
	            proj.calcThopt();
	        }

	        //calcul des performances globales du moteur
	        double Cin=diff.getInletVelocity();
	        double Cout0=nozzle[0].getOutletVelocity();
	        double airFlow=diff.getFlow();
	        double combustionFlow=airFlow;
	        if(!combustionChamberName.equals("")){
                String[] args=new String[2];
                args[0]="process";
                args[1]=combustionChamberName;
                Vector vProp=proj.getProperties(args);
                Double f=(Double)vProp.elementAt(3);
                combustionFlow=f.doubleValue();
	        }
	        double fAR=combustionFlow/airFlow-1;//fuel air ratio
	        double specThrust=((1+fAR)*Cout0-Cin)/1000;
	        thrust_value.setText("");
	        double specFuelCons=fAR/specThrust;
	        fuel_value.setText("");
	        thrust[k]=specThrust;
	        conso[k]=specFuelCons;
	    }
	    sauv_ini();
	}
	
    public void sauv_ini(){

        try{
            File fich2=new File("res"+File.separator,"thrust.txt");
	        FileWriter out = new FileWriter(fich2);
	        char[]data = new char[1000];
	        String h =new String();
	        h="Simulation results"+ligne;
	        
	        h = h+"Ma"+tab+Ma+tab+"Pext"+tab+Pext+tab+"Text"+tab+Text+ligne+ligne;


			for(int i=0 ;i<taux.length;i++){
			    h=h+taux[i]+tab+thrust[i]+tab+conso[i]+ligne;
			}

	        h=h+ligne; 

	        data=h.toCharArray();
	        int data_length=h.length();
	        out.write(data,0,data_length);
	        out.flush();
	        out.close();
        }
        catch(Exception e){System.out.println(e);}
    }
	


	void bCalculate_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//First initialization	    
        Pext=Util.lit_d(ambiantP_value.getText());//pression extrieure / ambient pressure (bar)
        Text=Util.lit_d(ambientT_value.getText());//temprature extrieure / ambient temperature (K)
        diff.setAmbientConditions(Text, Pext);//mise  jour du point amont du diffuseur / diffuser update
	    nozzle[0].setExternalPressure(Pext);//mise  jour de la pression en aval de la tuyre / nozzle update
        Ma=Util.lit_d(planeMach_value.getText());//Mach de l'avion / plane Mach number
	    double C=diff.getSpeed(Ma, Text, Pext);//vitesse en amont du diffuseur / velocity at the diffuser inlet
	    diff.setInletVelocity(C);	    
	    double comprRatio=Util.lit_d(comprRatio_value.getText());//rapport de compression / compression ratio
	    for(int i=0;i<3;i++){//on effectue 3 recalculs pour garantir la convergence
	    					//three calculations are performed to ensure convergence
	        if(!combustionChamberName.equals("")){//mise  jour du compresseur
                String[] args=new String[2];
                args[0]="process";
                args[1]=compressorName;
                Vector vProp=proj.getProperties(args);
                String amont=(String)vProp.elementAt(1);
                String aval=(String)vProp.elementAt(2);
                args[0]="point";
                args[1]=amont;
                vProp=proj.getProperties(args);
                Double f=(Double)vProp.elementAt(3);
                double Pamont=f.doubleValue();
                
                double Paval=Pamont*comprRatio;//mise  jour du point aval du compresseur
                								//update of the compressor outlet point
                Vector vPoint=new Vector();
                vPoint.addElement(aval);
                vPoint.addElement("false");//update temperature
                vPoint.addElement("0");
                vPoint.addElement("true");//update pressure
                vPoint.addElement(Util.aff_d(Paval));
                vPoint.addElement("false");
                vPoint.addElement("1");
                proj.updatePoint(vPoint);
	        }
	        proj.calcThopt();
	    }
	    //calcul des performances globales du moteur
	    //overall turbojet performance
	    double Cin=diff.getInletVelocity();
	    double Cout0=nozzle[0].getOutletVelocity();
	    double airFlow=diff.getFlow();
	    double combustionFlow=airFlow;
	    if(!combustionChamberName.equals("")){
            String[] args=new String[2];
            args[0]="process";
            args[1]=combustionChamberName;
            Vector vProp=proj.getProperties(args);
            Double f=(Double)vProp.elementAt(3);
            combustionFlow=f.doubleValue();
	    }
	    double fAR=combustionFlow/airFlow-1;//fuel air ratio
	    double specThrust=((1+fAR)*Cout0-Cin)/1000;
	    thrust_value.setText(Util.aff_d(specThrust, 3));
	    double specFuelCons=fAR/specThrust;
	    fuel_value.setText(Util.aff_d(specFuelCons, 5));
	}
}